import java.applet.*;	
import java.awt.*;
import java.lang.*;
import java.lang.reflect.*;

public class actual extends Applet implements Runnable
{
  /*dimensions of applet*/
  int W=300,H=113,skyW=900;
  /*the main thread of execution
  and its checking variable*/
  Thread mainThread=null;
	/*positions of scrolling sky, its speed
	its source image*/
	int xSky=0,xSkyStep=20;
	Image sky;
	String skyFile;
	/*logo source and dimensions*/
	Image logo;	
	String logoFile;
	int logoHeight=165,logoWidth=400;
	int x0=W/2,y0=H/2;
	/*double buffering implementation objects*/
	Image offScreenImage;
	Graphics offScreenGraphic;
	/*loading images controlling object*/
	MediaTracker tracker;
	
	
	public void init()	
	{
   	
   	/*here we read parameters given by html file/*
   	
   	/*read applet dimension*/
   	String WString = getParameter("W");
		W = Integer.parseInt(WString);
		String HString = getParameter("H");
		H = Integer.parseInt(HString);
		
		/*setting of x0,y0 vs H,W */
		x0=W/2;
		y0=H/2;

		/*read sky width*/
		String skyWString = getParameter("skyW");
		skyW = Integer.parseInt(skyWString);
		
		/*read file name of sky*/
		skyFile = getParameter("skyFile");
		/*read file name of logo*/
		logoFile = getParameter("logoFile");
		
   	/*read scrolling sky step (speed) from html*/
		String xSkyStepString = getParameter("xSkyStep");
		xSkyStep = Integer.parseInt(xSkyStepString);
  	
  
  
  	/*read logo dimensions from html*/
  	String logoHeightString = getParameter("logoHeight");
		logoHeight = Integer.parseInt(logoHeightString);
		String logoWidthString = getParameter("logoWidth");
		logoWidth = Integer.parseInt(logoWidthString);

  	/*end of parameter reading/*
  
   	/*same settings*/
   	setBackground(Color.black);
    /*loading images with MediaTracker.
    The '0' is the loading ptiority*/    
    tracker = new MediaTracker(this);
  	sky = getImage(getCodeBase(),skyFile);
   	tracker.addImage(sky,0);
   	logo = getImage(getCodeBase(),logoFile);
   	tracker.addImage(logo,0);
 	
 	  /*for double buffering*/
 	  offScreenImage=createImage(W,H);
  	offScreenGraphic=offScreenImage.getGraphics();
 	}
	
	public void start()
	{
   	/*starting main execution Thread*/
   	if(mainThread == null)
		{
     	mainThread= new Thread(this);
			mainThread.start();
   	}
  }
	
	public void stop()
	{
		/*stop mainThread*/
		mainThread=null;
	}
	
	
	public void run()
	{
  	while(mainThread!=null)
		{
		 	/*wait for loading*/
		 	try 
    	{tracker.waitForID(0);} 
    	catch (InterruptedException e) {}
			/*clock time control of mainthread*/
			try{Thread.sleep(100);}
			catch(InterruptedException e){}
     	repaint();
    }
	 		mainThread=null;
	}
	
	/*overriding of update method for
	implementing double buffering*/
	public void update(Graphics g)
	{
		paint(g);
	}
		
	public void paint(Graphics g)
  {
		/*if loading is complete paints animation*/
		if (tracker.statusID(0, false) == MediaTracker.COMPLETE) 
   	{
   		/*offscreen deleting of image*/
   		offScreenGraphic.setColor(Color.black);
			offScreenGraphic.fillRect(0,0,W,H);
   		/*offscreen paintiong of scrolling sky
   		N.B. 'null' is imageObserver*/
   		if (xSky<-2*skyW+W)
				xSky=xSky+skyW;
			offScreenGraphic.drawImage(sky, xSky, 0,skyW,H,null);  	
   		offScreenGraphic.drawImage(sky,xSky+skyW,0,skyW,H,null);
   		xSky=xSky-xSkyStep;
   		/*offscreen painting of logo*/
			offScreenGraphic.drawImage(logo, x0-logoWidth/2, 0,logoWidth,logoHeight,null);  	
			/*offscreen painting of signature:HANK7V*/			
			//offScreenGraphic.drawString("Hank7V",W-60,H-20);
			/* PAINTING */
			g.drawImage(offScreenImage,0,0,null);
   	}//end if
		/*if loading is not complete paint message:loading...
		(N.B. paint it one time, then waitForID  in run()
		sleep applet until loading is complete*/
		else
   	{
			offScreenGraphic.setColor(Color.black);
			offScreenGraphic.fillRect(0,0,W,H);
			offScreenGraphic.setColor(Color.green);
			offScreenGraphic.drawString("Loading...",50,100);
			g.drawImage(offScreenImage,0,0,null);
   	}//end else		
	}//end of paint
}//end of applet
	